angular.module('starter.controllers', [])


// A simple controller that fetches a list of data from a service
.controller('MainController', function($scope, $ionicSideMenuDelegate, $ionicLoading, $http, $rootScope) {
	$scope.subscribed_topics = '';
	var data;

	//Show loading icon
	$rootScope.showLoading();
	
	//DB Setup
	var db = openDatabase('castDB', '1.0.0', 'Cast DB', 2 * 1024 * 1024);
	db.transaction(function (tx) {
	  tx.executeSql('SELECT * FROM subscription', [], function (tx, results) {
	   //Assign variables
	   var len = results.rows.length, i;
	   readTopicsFromDB(results);
	   
	   //$scope.subscribed_topics = results.rows.item(0).topic_id;
	   //console.log($scope.subscribed_topics);
	   
	 }, null);
	});
	
	var readTopicsFromDB = function(results)
	{
		var dataList = $.param({topic_id: results.rows.item(0).topic_id});
		//dataList = {'id':"'"+ results.rows.item(0).topic_id +"'"};
		//console.log(data);

		$http({
			method: 'POST', 
		    headers: {'Content-Type': 'application/x-www-form-urlencoded'}, 
			data: dataList, 
			url: $rootScope.serverLocation + '/api/v1/news/topics'}).
			success(function(data, status, headers, config) {
				$scope.articles = data;

				//Hide loading icon
				$rootScope.hideLoading();
	
			}).
			error(function(data, status, headers, config) {
			// called asynchronously if an error occurs
			// or server returns response with an error status.
		});


	};

	/*
	//Left navigation button
	$scope.leftButtons = [{
		type: 'button-icon icon ion-navicon',
		tap: function(e) {
			$scope.sideMenuController.toggleLeft();
		}
	}];
	*/



  	//$scope.pets = PetService.all();
})

// A simple controller that fetches a list of data from a service
.controller('NewsTopicController', function($scope, $stateParams, $http, $sce, $ionicSideMenuDelegate, $ionicLoading, $rootScope) {

	/*
	$scope.leftButtons = [{
		type: 'button-icon icon ion-navicon',
		tap: function(e) {
			$scope.sideMenuController.toggleLeft();
		}
	}];
	*/
	
	//Show loading icon
	$rootScope.showLoading();

    $http({method: 'GET', url: $rootScope.serverLocation + '/api/v1/news/' + $stateParams.topicID}).
		success(function(data, status, headers, config) {
			$scope.articles = data;
			
			//Hide loading icon
			$rootScope.hideLoading();
		}).
		error(function(data, status, headers, config) {
		// called asynchronously if an error occurs
		// or server returns response with an error status.
    });

  	//$scope.pets = PetService.all();
})

// A simple controller that fetches a list of data from a service
.controller('TopicsController', function($scope, $ionicSideMenuDelegate, $http, $rootScope) {

    $http({method: 'GET', url: $rootScope.serverLocation + '/api/v1/topics/'}).
		success(function(data, status, headers, config) {
			$scope.topics = data;

		}).
		error(function(data, status, headers, config) {
		// called asynchronously if an error occurs
		// or server returns response with an error status.
    });

  	//$scope.pets = PetService.all();
})

// A simple controller that fetches a list of data from a service
.controller('SetupController', function($scope, $ionicSideMenuDelegate, $http, $rootScope, $state) {
	var topics_selected = '';
	
	//Disable button
	$('.buildSetup').attr('disabled', 'disabled');

	//Atleast one topic selected
	$scope.change = function() {
	  if ($('.topic_check:checked').length) {
		  $('.buildSetup').removeAttr('disabled');
	  } else {
		  $('.buildSetup').attr('disabled', 'disabled');
	  }
	};
	  
    $scope.submitSetupForm = function() {
		//GET SELECTED TOPICS TO SUBSCRIBE
		var topics_selected = $("input[name='topics_selected']:checked").valueList(); 
		
		//INSERT INTO DATABASE
		var db = openDatabase('castDB', '1.0.0', 'Cast DB', 2 * 1024 * 1024);
		db.transaction(function (tx) {  
		   tx.executeSql('CREATE TABLE IF NOT EXISTS subscription (topic_id)');
		   tx.executeSql('DELETE FROM subscription');
		   tx.executeSql("INSERT INTO subscription (topic_id) VALUES ('" + topics_selected + "')");
		});
		
		$state.go('tab.news-index');
    };
	

    $http({method: 'GET', url: $rootScope.serverLocation + '/api/v1/topics/'}).
		success(function(data, status, headers, config) {
			$scope.topics = data;

			//Hide loading icon
			$rootScope.hideLoading();

		}).
		error(function(data, status, headers, config) {
		// called asynchronously if an error occurs
		// or server returns response with an error status.
    });

  	//$scope.pets = PetService.all();
})

// A simple controller that fetches a list of data from a service
.controller('SettingController', function($scope, $http, $rootScope) {
	//console.log('test');
})


// A simple controller that fetches a list of data from a service
.controller('ContentController', function($scope, $stateParams, $http, $sce, $rootScope, $ionicActionSheet, $ionicPopup, $location, $anchorScroll) {
	//Defaults
	$scope.articleSummaryStatus = true;
	$scope.fullArticleStatus = false;

	//Summary
	var section = 1;
	
    $scope.section = function (id) {
        section = id;   
    };
    
    $scope.is = function (id) {
        return section == id;
    };
	
	
	$scope.fullArticle = function (event) {
		$scope.articleSummaryStatus = false;
		$scope.fullArticleStatus = true;

		//resize content area
		//$scope.$broadcast('scroll.resize');
		$location.hash('top');
		$anchorScroll();		
		$scope.$broadcast('scroll.resize');

		if(!$scope.$$phase) {
			$scope.$apply();			
		
		}

			$( ".fullArticle a" ).click(function() {
				window.plugins.ChildBrowser.showWebPage($(this).attr("href"),
                                        { showLocationBar: false , showAddress: false});			
				return false;
			});

		return false;
	};

	$scope.articleSummary = function (event) {
		$scope.articleSummaryStatus = true;
		$scope.fullArticleStatus = false;

		//resize content area
		$location.hash('top');
		$anchorScroll();		
		//$scope.$apply();		
		$scope.$broadcast('scroll.resize');

		if(!$scope.$$phase) {
			$scope.$apply();			
		}


		return false;
	};

	$scope.sourceLink = function (event) {
		window.plugins.ChildBrowser.showWebPage($(".sourceLink").attr("data-source"),
								{ showLocationBar: true , showAddress: false});			
		
		return false;
	};


	$scope.socialShare = function (event) {
	   // Show the action sheet
	   $ionicActionSheet.show({
		 buttons: [
		   { text: 'Share' },
		   { text: 'Bookmark' },
		 ],
		 //titleText: 'Share or Bookmark',
		 buttonClicked: function(index) {
			 //share
			 if(index == 0)
			 {
				window.plugins.socialsharing.share($scope.articles[0].title + " via NewsCast app", $scope.articles[0].title + " - NewsCast", $scope.articles[0].image_url, $scope.articles[0].url);
			 }
			 //share twitter
			 else if(index == 1)
			 {
				 //console.log('writing to db start');
				 
				//INSERT INTO DATABASE
				var db = openDatabase('castDB', '1.0.0', 'Cast DB', 2 * 1024 * 1024);
				db.transaction(function (tx) {  
				   tx.executeSql("INSERT INTO bookmark (article_id, title, image_url) VALUES ('" 
				   														+ $scope.articles[0].article_id + "', "
																		+ "'" + $scope.articles[0].title +  "', "
																		+ "'" + $scope.articles[0].image_url +  

																		"')");
				});


				$ionicPopup.alert({
					title: 'Bookmark Saved!'
				});

				 //console.log('writing to db end');


			 }

			 
		     return true;
		 }
	   });

		return false;
	};
	
	//Show loading icon
	$rootScope.showLoading();

	//Show summary at first
	$scope.articleSummary();

    $http({method: 'GET', url: $rootScope.serverLocation + '/api/v1/contents/' + $stateParams.articleID}).
		success(function(data, status, headers, config) {
			$scope.articles = data;
			$scope.authors = angular.toJson($scope.articles.author);
			
			//console.log($scope.authors);

			//Hide loading icon
			$rootScope.hideLoading();

			$scope.dspSummary = function() {
			return $sce.trustAsHtml($scope.articles.summary);
			};

		}).
		error(function(data, status, headers, config) {
		// called asynchronously if an error occurs
		// or server returns response with an error status.
    });


  	//$scope.pets = PetService.all();
})


// A simple controller that fetches a list of data from a service
.controller('BookmarkController', function($scope, $http, $rootScope, $http, $ionicSideMenuDelegate) {

	//DB Setup
	var db = openDatabase('castDB', '1.0.0', 'Cast DB', 2 * 1024 * 1024);
	db.transaction(function (tx) {
	  tx.executeSql('SELECT * FROM bookmark', [], function (tx, results) {
	   //Assign variables
	   var len = results.rows.length, i;
	   $scope.bookmarkLength = results.rows.length;
  	   //$scope.$apply();			
		if(!$scope.$$phase) {
			$scope.$apply();			
		}

	   //console.log($scope.bookmarkLength);
	   //console.log(results.rows.item(0).title);
	   
		$scope.db_result = [];	   
		for (var i = 0; i < len; i++){
            $scope.db_result[i] = results.rows.item(i);
			//$scope.$apply();			
			if(!$scope.$$phase) {
				$scope.$apply();			
			}
			
		}

		//console.log($scope.db_result);
	   
	   //$scope.subscribed_topics = results.rows.item(0).topic_id;
	   //console.log($scope.subscribed_topics);
	   
	 }, null);
	});


	if(!$scope.$$phase) {
		$scope.$apply();			
	}

	//console.log('bookmark');
})


// A simple controller that shows a tapped item's data
.controller('PetDetailCtrl', function($scope, $stateParams, $http, $sce, $ionicSideMenuDelegate, $rootScope) {

	//console.log($stateParams);

 /* $scope.article = [];
  var articlesData =  $http.get($rootScope.serverLocation + '/api/v1/news/' + $stateParams.articleID).success(function(data)
  {
	$scope.article = data;

	$scope.dspSummary = function() {
	return $sce.trustAsHtml($scope.article.summary);
	};

	//$scope.article = data;
	//$scope.article = data;
  });
  */
    $http({method: 'GET', url: $rootScope.serverLocation + '/api/v1/contents/' + $stateParams.articleID}).
		success(function(data, status, headers, config) {
			$scope.articles = data;

			//console.log($scope.articles);

			$scope.dspSummary = function() {
			return $sce.trustAsHtml($scope.article.summary);
			};
		}).
		error(function(data, status, headers, config) {
		// called asynchronously if an error occurs
		// or server returns response with an error status.
    });
  
  
  
  //$scope.pet = PetService.get($stateParams.petId);
});
